Further parameterization of the burn-image.sh script.
[backups/.git] / scripts / restore-script.sh
old mode 100644 (file)
new mode 100755 (executable)
index 402bb84..e4fba47
@@ -1,24 +1,80 @@
 #!/bin/sh
 
-if [ $# != 1 ]; then
-  echo >&2 "Usage: $0 <target-directory>"
-  echo >&2 "Example: $0 /"
+function err() {
+  echo >&2 "-E- $1"
   exit 1
+}
+
+[ -n "$3" ] && mountdir=$3
+
+[ -z "$mountdir" ] && err '$mountdir must be set'
+
+rundir=${rundir:-$(dirname $0)}
+
+export PATH=${rundir%/}:/bin:/usr/bin:/sbin:/usr/sbin:/sw/bin
+
+if [ -z "$1" -o ! -d "$2" ]; then
+  err "
+
+Usage: $(basename $0) <source-dir> <relocate-dir> [<mnt-dir>]
+  source-dir   - Directory on backup disks to restore (relative to
+                 $mountdir)
+  relocate-dir - Base directory to restore files into (usually /)
+  mnt-dir      - Directory where backup disk is mounted (optional)
+
+Examples:
+  # Restore everything from disks (explicitly specifying dvd mount point.)
+  % $(basename $0) / / /mnt/cdrom
+
+  # Restore everything from disks
+  % $(basename $0) / /
+
+  # Restore only files under /home on disks to /home on the system
+  % $(basename $0) /home /
+
+  # Restore files under /home on disks to /home/home on the system
+  # (this is usually not what you want.)
+  % $(basename $0) /home /home
+"
 fi
 
-tmpdir=/tmp/restore-$(date +%Y%m%d%H%M%S)
+device=$(mount | grep "on ${mountdir%/} " | awk '{print$1}')
+
+[ -z "$device" ] && err "Cannot determine cdrom device"
+
+cp ${mountdir%/}/backups.db ${mountdir%/}/backup-status.txt $rundir
+dbfile=${rundir%/}/backups.db
+
+dates=$(cat $dbfile | list-dates.sh)
+
+for date in $dates; do
+  filelist=$(tempfile)
+  # Check to see if files are actually needed from the current disk before requesting it.
+  cat $dbfile | files-from-date.sh $date | grep -z -Z -e "^${1%/}/" > $filelist
+  if [ -s $filelist ]; then
+    success=false
+    while ! $success; do
+      eject $device
+      [ $? != 0 ] && err "Cannot eject the disk. Drive is busy. Run lsof $mountdir to see why."
+      echo "Please insert backup disk:  $date"
+      echo "Press Enter to continue"
+      read bogus
+      eject -t $device
 
-export PATH=$tmpdir:/bin:/usr/bin
+      # Mount the media
+      mount -t ext2 $device ${mountdir%/}
 
-# Get the device with the CD in it here
-device=/dev/hdc
+      if grep -q $date ${mountdir%/}/backup-status.txt; then
+        success=true
+      else
+        echo "This doesn't seem to be the right disk."
+      fi
+    done
 
-for date in $(cat $dbfile | list-dates.sh); do
-  eject $device
-  echo >&2 "Please insert backup disk:  $date"
-  echo >&2 "Then press any key"
-  read bogus
-  # Mount the media
-  # rsync-cmd.sh won't work here in its current encarnation
-  cat $dbfile | files-from-date.sh | rsync-cmd.sh $1
+    rsyncopts="-W -H -S -l -p -t -g -o -0 --files-from=- --stats --progress"
+    cat $filelist | rsync $rsyncopts ${mountdir%/}/ ${2%/}/
+  else
+    echo "No files are needed from disk: $date.  Skipping it."
+  fi
+  rm -f $filelist
 done